import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:rasadyar_chicken/presentation/widget/base_page/view.dart';
import 'package:rasadyar_chicken/presentation/widget/captcha/view.dart';
import 'package:rasadyar_core/core.dart';

import 'logic.dart';

class AuthPage extends GetView<AuthLogic> {
  const AuthPage({super.key});

  @override
  Widget build(BuildContext context) {
    return ChickenBasePage(
      isFullScreen: true,
      backGroundWidget: backGroundDecoration(
        gradient: LinearGradient(
          begin: Alignment.topRight,
          end: Alignment.bottomLeft,
          colors: [
            const Color(0xFFB2C9FF).withValues(alpha: 1.0), // 0%
            const Color(0xFF40BB93).withValues(alpha: 0.11), // 50%
            const Color(0xFF93B6D3).withValues(alpha: 1.0), // 100%
          ],
          stops: const [0.0, 0.5, 1.0],
        ),
        backgroundPath: Assets.images.patternChicken.path,
      ),
      onPopScopTaped: () => Get.back(result: -1),
      child: Stack(
        children: [
          Center(
            child: Padding(
              padding: EdgeInsets.symmetric(horizontal: 10.r),
              child: FadeTransition(
                opacity: controller.textAnimation,
                child: Column(
                  mainAxisSize: MainAxisSize.min,
                  mainAxisAlignment: MainAxisAlignment.start,
                  crossAxisAlignment: CrossAxisAlignment.center,
                  spacing: 12,
                  children: [
                    Text(
                      'به سامانه رصدطیور خوش آمدید!',
                      textAlign: TextAlign.right,
                      style: AppFonts.yekan25Bold.copyWith(color: AppColor.darkGreyDarkActive),
                    ),
                    Text(
                      'سامانه رصد و پایش زنجیره تامین، تولید و توزیع کالا های اساسی',
                      textAlign: TextAlign.center,
                      style: AppFonts.yekan16.copyWith(color: AppColor.darkGreyDarkActive),
                    ),
                  ],
                ),
              ),
            ),
          ),

          Obx(() {
            final screenHeight = MediaQuery.of(context).size.height;
            final targetTop = (screenHeight - 676) / 2;

            return AnimatedPositioned(
              duration: const Duration(milliseconds: 1200),
              curve: Curves.linear,
              top: controller.showCard.value ? targetTop : screenHeight,
              left: 10.r,
              right: 10.r,
              child: Container(
                width: 381.w,
                height: 676.h,
                decoration: BoxDecoration(
                  color: Colors.white,
                  borderRadius: BorderRadius.circular(40),
                ),
                child: Column(
                  children: [
                    SizedBox(height: 50.h),
                    LogoWidget(
                      vecPath: Assets.vec.rasadToyorSvg.path,
                      width: 85.w,
                      height: 85.h,
                      titleStyle: AppFonts.yekan20Bold.copyWith(color: Color(0xFF4665AF)),
                      title: 'رصدطیور',
                    ),
                    SizedBox(height: 20.h),
                    useAndPassFrom(),
                    SizedBox(height: 24.h),
                    RichText(
                      text: TextSpan(
                        children: [
                          TextSpan(
                            text: 'مطالعه بیانیه ',
                            style: AppFonts.yekan16.copyWith(color: AppColor.darkGreyDark),
                          ),
                          TextSpan(
                            recognizer: TapGestureRecognizer()
                              ..onTap = () {
                                Get.bottomSheet(
                                  privacyPolicyWidget(),
                                  isScrollControlled: true,
                                  enableDrag: true,
                                  ignoreSafeArea: false,
                                );
                              },
                            text: 'حریم خصوصی',
                            style: AppFonts.yekan16.copyWith(color: AppColor.blueNormal),
                          ),
                        ],
                      ),
                    ),
                  ],
                ),
              ),
            );
          }),
        ],
      ),
    );
  }

  Widget useAndPassFrom() {
    return Padding(
      padding: EdgeInsets.symmetric(horizontal: 30.r),
      child: Form(
        key: controller.formKey,
        child: AutofillGroup(
          child: Column(
            children: [
              RTextField(
                label: 'نام کاربری',
                maxLength: 11,
                maxLines: 1,
                controller: controller.usernameController.value,
                keyboardType: TextInputType.number,
                initText: controller.usernameController.value.text,
                autofillHints: [AutofillHints.username],
                focusedBorder: OutlineInputBorder(
                  borderRadius: BorderRadius.circular(8),
                  borderSide: BorderSide(color: AppColor.textColor, width: 1),
                ),
                onChanged: (value) async {
                  controller.usernameController.value.text = value;
                  if (value.length == 11) {
                    await controller.getUserInfo(value);
                  }
                },
                prefixIcon: Padding(
                  padding: const EdgeInsets.fromLTRB(0, 8, 6, 8),
                  child: Assets.vec.callSvg.svg(width: 12, height: 12),
                ),
                suffixIcon: controller.usernameController.value.text.trim().isNotEmpty
                    ? clearButton(() {
                        controller.usernameController.value.clear();
                        controller.usernameController.refresh();
                      })
                    : null,
                validator: (value) {
                  if (value == null || value.isEmpty) {
                    return '⚠️ شماره موبایل را وارد کنید';
                  } else if (value.length < 10) {
                    return '⚠️ شماره موبایل باید 11 رقم باشد';
                  }
                  return null;
                },
                style: AppFonts.yekan13,
                errorStyle: AppFonts.yekan13.copyWith(color: AppColor.redNormal),
                labelStyle: AppFonts.yekan13,
                boxConstraints: const BoxConstraints(
                  maxHeight: 40,
                  minHeight: 40,
                  maxWidth: 40,
                  minWidth: 40,
                ),
              ),
              const SizedBox(height: 26),
              ObxValue(
                (passwordController) => RTextField(
                  label: 'رمز عبور',
                  filled: false,
                  obscure: true,
                  focusedBorder: OutlineInputBorder(
                    borderRadius: BorderRadius.circular(8),
                    borderSide: BorderSide(color: AppColor.textColor, width: 1),
                  ),
                  controller: passwordController.value,
                  autofillHints: [AutofillHints.password],
                  variant: RTextFieldVariant.password,
                  initText: passwordController.value.text,
                  onChanged: (value) {
                    passwordController.refresh();
                  },
                  validator: (value) {
                    if (value == null || value.isEmpty) {
                      return '⚠️ رمز عبور را وارد کنید';
                    }
                    return null;
                  },
                  style: AppFonts.yekan13,
                  errorStyle: AppFonts.yekan13.copyWith(color: AppColor.redNormal),
                  labelStyle: AppFonts.yekan13,
                  prefixIcon: Padding(
                    padding: const EdgeInsets.fromLTRB(0, 8, 8, 8),
                    child: Assets.vec.keySvg.svg(width: 12, height: 12),
                  ),
                  boxConstraints: const BoxConstraints(
                    maxHeight: 34,
                    minHeight: 34,
                    maxWidth: 34,
                    minWidth: 34,
                  ),
                ),
                controller.passwordController,
              ),
              SizedBox(height: 26),
              CaptchaWidget(),

              GestureDetector(
                onTap: () {
                  controller.rememberMe.value = !controller.rememberMe.value;
                },
                child: Row(
                  children: [
                    ObxValue((data) {
                      return Checkbox(
                        materialTapTargetSize: MaterialTapTargetSize.shrinkWrap,
                        visualDensity: VisualDensity(horizontal: -4, vertical: 4),
                        tristate: true,
                        value: data.value,
                        onChanged: (value) {
                          data.value = value ?? false;
                        },
                        shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(4)),
                        activeColor: AppColor.blueNormal,
                      );
                    }, controller.rememberMe),
                    Text(
                      'مرا به خاطر بسپار',
                      style: AppFonts.yekan14.copyWith(color: AppColor.darkGreyDark),
                    ),
                  ],
                ),
              ),

              Obx(() {
                return RElevated(
                  text: 'ورود',
                  isLoading: controller.isLoading.value,
                  onPressed: controller.isDisabled.value
                      ? null
                      : () async {
                          await controller.submitLoginForm();
                        },
                  width: Get.width,
                  height: 48,
                );
              }),
            ],
          ),
        ),
      ),
    );
  }

  Widget privacyPolicyWidget() {
    return BaseBottomSheet(
      child: Column(
        spacing: 5,
        children: [
          Container(
            padding: EdgeInsets.all(8.w),

            decoration: BoxDecoration(
              color: Colors.white,
              borderRadius: BorderRadius.circular(8),
              border: Border.all(color: AppColor.darkGreyLight, width: 1),
            ),
            child: Column(
              spacing: 3,
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  'بيانيه حريم خصوصی',
                  style: AppFonts.yekan16Bold.copyWith(color: AppColor.blueNormal),
                ),
                Text(
                  'اطلاعات مربوط به هر شخص، حریم خصوصی وی محسوب می‌شود. حفاظت و حراست از اطلاعات شخصی در سامانه رصد یار، نه تنها موجب حفظ امنیت کاربران می‌شود، بلکه باعث اعتماد بیشتر و مشارکت آنها در فعالیت‌های جاری می‌گردد. هدف از این بیانیه، آگاه ساختن شما درباره ی نوع و نحوه ی استفاده از اطلاعاتی است که در هنگام استفاده از سامانه رصد یار ، از جانب شما دریافت می‌گردد. شرکت هوشمند سازان خود را ملزم به رعایت حریم خصوصی همه شهروندان و کاربران سامانه دانسته و آن دسته از اطلاعات کاربران را که فقط به منظور ارائه خدمات کفایت می‌کند، دریافت کرده و از انتشار آن یا در اختیار قرار دادن آن به دیگران خودداری مینماید.',
                  style: AppFonts.yekan14.copyWith(color: AppColor.bgDark, height: 1.8),
                ),
              ],
            ),
          ),
          Container(
            padding: EdgeInsets.all(8.w),

            decoration: BoxDecoration(
              color: Colors.white,
              borderRadius: BorderRadius.circular(8),
              border: Border.all(color: AppColor.darkGreyLight, width: 1),
            ),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              spacing: 4,
              mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Text(
                  'چگونگی جمع آوری و استفاده از اطلاعات کاربران',
                  style: AppFonts.yekan16Bold.copyWith(color: AppColor.blueNormal),
                ),
                Text(
                  '''الف: اطلاعاتی که شما خود در اختيار این سامانه قرار می‌دهيد، شامل موارد زيرهستند:
اقلام اطلاعاتی شامل شماره تلفن همراه، تاریخ تولد، کد پستی و کد ملی کاربران را دریافت مینماییم که از این اقلام، صرفا جهت احراز هویت کاربران استفاده خواهد شد.
ب: برخی اطلاعات ديگر که به صورت خودکار از شما دريافت میشود شامل موارد زير می‌باشد:
⦁ دستگاهی که از طریق آن سامانه رصد یار را مشاهده می‌نمایید( تلفن همراه، تبلت، رایانه).
⦁ نام و نسخه سیستم عامل و browser کامپیوتر شما.
⦁ اطلاعات صفحات بازدید شده.
⦁ تعداد بازدیدهای روزانه در درگاه.
⦁ هدف ما از دریافت این اطلاعات استفاده از آنها در تحلیل عملکرد کاربران درگاه می باشد تا بتوانیم در خدمت رسانی بهتر عمل کنیم.
''',
                  style: AppFonts.yekan14.copyWith(color: AppColor.bgDark, height: 1.8),
                ),
              ],
            ),
          ),
          Container(
            padding: EdgeInsets.all(8.w),

            decoration: BoxDecoration(
              color: Colors.white,
              borderRadius: BorderRadius.circular(8),
              border: Border.all(color: AppColor.darkGreyLight, width: 1),
            ),
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              spacing: 4,
              mainAxisAlignment: MainAxisAlignment.start,
              children: [
                Text(
                  'امنیت اطلاعات',
                  style: AppFonts.yekan16Bold.copyWith(color: AppColor.blueNormal),
                ),
                Text(
                  'متعهدیم که امنیت اطلاعات شما را تضمین نماییم و برای جلوگیری از هر نوع دسترسی غیرمجاز و افشای اطلاعات شما از همه شیوه‌‌های لازم استفاده می‌کنیم تا امنیت اطلاعاتی را که به صورت آنلاین گردآوری می‌کنیم، حفظ شود. لازم به ذکر است در سامانه ما، ممکن است به سایت های دیگری لینک شوید، وقتی که شما از طریق این لینک‌ها از سامانه ما خارج می‌شوید، توجه داشته باشید که ما بر دیگر سایت ها کنترل نداریم و سازمان تعهدی بر حفظ حریم شخصی آنان در سایت مقصد نخواهد داشت و مراجعه کنندگان میبایست به بیانیه حریم شخصی آن سایت ها مراجعه نمایند.',
                  style: AppFonts.yekan14.copyWith(color: AppColor.bgDark, height: 1.8),
                ),
              ],
            ),
          ),
        ],
      ),
    );
  }
}
